//
//  File:           DrawPanel.java
//  Description:    
//  Created:        14.05.97
//  Last Modified:  14.05.97
//  Author:         Bettina Speckmann
//  mail:           speckman@cs.ubc.ca
//

import java.awt.*;
import CompGeom.Point;
import Triangulation;


public class DrawPanel extends Panel {
  public Triangulation t;
  Graphics graphics = null;

  
  public DrawPanel() {

    t = new Triangulation(200);
    setBackground(Color.white);
    setForeground(Color.black);
  }
    

  public boolean handleEvent(Event e) {

    if (graphics == null) { 
      graphics = getGraphics();
    }

    switch (e.id) {
    case Event.MOUSE_DOWN:
      graphics.drawOval(e.x-3, e.y-3, 6, 6);
      return true;
      
    case Event.MOUSE_UP:
      t.insert(new Point(e.x, -e.y));
      repaint();
      return true;
      
    case Event.MOUSE_DRAG:
      repaint();
      graphics.drawOval(e.x-3, e.y-3, 6, 6);
      return true;
      
    case Event.WINDOW_DESTROY:
      // t.finalize();
      System.exit(0);
      return true;

    default:
      return false;
    }
  }

  
  public void paint(Graphics g) {

    t.draw(g);
  }

}


class DrawControls extends Panel {
  DrawPanel target;
  
  public DrawControls(DrawPanel target) {
    this.target = target;
    setLayout(new FlowLayout());
    setBackground(Color.lightGray);
    add(new Button("Reset"));
    add(new Button ("Quit"));
  }
    
  public boolean action(Event e, Object arg) {
    if (e.target instanceof Button) {
    	String buttonName = (String)arg;
	if (buttonName.equals("Quit")) System.exit(0);
	if (buttonName.equals("Reset")) target.t.clearcounts();
    }
    target.repaint();
    return true;
  }

}
